/* Copyright (C) 2006 P.L. Lucas
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef __SYNTAX_H__
#define __SYNTAX_H__
#include <QTextEdit>
#include <QSyntaxHighlighter>
#include <QVector>
#include <QTextCharFormat>
#include <QMap>

class Syntax: public QSyntaxHighlighter
{
 public:
  Syntax(QTextEdit *parent);
  void highlightBlock(const QString &str);
  void load(const QString &file);

  void setItem(const QString &item, const QString &type);
  void setComment(const QString &start, const QString &end, const QString &type);
  void setType(const QString &type, const QTextCharFormat &format);
 private:
  struct Rule
  {
    QRegExp pattern;
    QString type;
    QTextCharFormat format;
  };

  static QMap<QString, QVector<Rule> > instances;

  QVector<Rule> *rules;
  QMap<QString, QTextCharFormat> format;
};

#endif
